<?php
/**
 * Wicked base inclusion file.
 *
 * This file brings in all of the dependencies that every Wicked
 * script will need and sets up objects that all scripts use.
 *
 * $Horde: wicked/lib/base.php,v 1.15 2008-01-06 23:07:48 chuck Exp $
 *
 * Copyright 2003-2008 The Horde Project (http://www.horde.org/)
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

// Check for a prior definition of HORDE_BASE (perhaps by an
// auto_prepend_file definition for site customization).
if (!defined('HORDE_BASE')) {
    define('HORDE_BASE', dirname(__FILE__) . '/../..');
}

// Load the Horde Framework core, and set up inclusion paths.
require_once HORDE_BASE . '/lib/core.php';

// Registry.
$registry = &Registry::singleton();
if (is_a(($pushed = $registry->pushApp('wicked', !defined('AUTH_HANDLER'))), 'PEAR_Error')) {
    if ($pushed->getCode() == 'permission_denied') {
        Horde::authenticationFailureRedirect();
    }
    Horde::fatal($pushed, __FILE__, __LINE__, false);
}
$conf = &$GLOBALS['conf'];
define('WICKED_TEMPLATES', $registry->get('templates'));

// Find the base file path of Wicked.
if (!defined('WICKED_BASE')) {
    define('WICKED_BASE', dirname(__FILE__) . '/..');
}

// Notification system.
$notification = &Notification::singleton();
$notification->attach('status');

// Wicked base libraries.
require_once WICKED_BASE . '/lib/Wicked.php';
require_once WICKED_BASE . '/lib/Driver.php';
require_once WICKED_BASE . '/lib/Page.php';
$GLOBALS['wicked'] = Wicked_Driver::factory();

// Horde libraries.
require_once 'Horde/Help.php';

// Start compression.
if (!Util::nonInputVar('no_compress')) {
    Horde::compressOutput();
}
